# **********************************************************************
#
# Copyright (c) 1998
# Object-Oriented Concepts, Inc.
# Billerica, MA, USA
#
# Copyright (c) 1998
# Object-Oriented Concepts GmbH
# Ettlingen, Germany
#
# All Rights Reserved
#
# **********************************************************************

# ----------------------------------------------------------------------
# Define OLD_IOSTREAM as "yes" if you want to use the old iostream
# library, i.e., if you want to use '#include <iostream.h>" instead of
# "#include <iostream>". 
# Note: If you want to check your application with "purify", please
# use the old iostream library instead of the new one. If the new one
# is used, purify will detect lots of non-existent memory problems.
# ----------------------------------------------------------------------

#OLD_IOSTREAM=yes

# ----------------------------------------------------------------------
# If you want to make use of a Dynamic Link Library (DLL) instead of a
# static library in the packages where this is supported, uncomment
# the following line to define DLL as "yes". Note that in this case
# you need "perl" for the compilation process.
# Note: If you want to compile ORBacus with JThreads/C++ support as
# a DLL, you must also compile JThreads/C++ as a DLL.
# ----------------------------------------------------------------------

#DLL=yes

# ----------------------------------------------------------------------
# If you want to compile ORBacus with JThreads/C++ support, or if
# you want to compile some other package based on an ORBacus
# version which was compiled with JThreads/C++ support, uncomment the
# following line to define WITH_JTC as "yes".
# ----------------------------------------------------------------------

#WITH_JTC=yes

# ----------------------------------------------------------------------
# If you are compiling JThreads/C++, and you want support for the
# stop, suspend and resume operations, uncomment the following line to
# define WITH_JTC_STOP as "yes".
# Note: ORBacus does not require support for stop, suspend or resume,
# so it's safe (and about 10% faster) to leave this option untouched.
# ----------------------------------------------------------------------

#WITH_JTC_STOP=yes

# ----------------------------------------------------------------------
# Use the following lines to set your installation directories
# ----------------------------------------------------------------------

prefix          = C:\OOC
bindir          = $(prefix)\bin
libdir          = $(prefix)\lib
includedir      = $(prefix)\include

# ----------------------------------------------------------------------
# If JThreads/C++ support is enabled, use the following line to set
# the JThreads/C++ installation path.
# ----------------------------------------------------------------------

JTC_DIR=$(prefix)

# ----------------------------------------------------------------------
# If you compile any program that depends on ORBacus (for example
# ORBacus SSL), use the following line to set the ORBacus installation
# path.
# ----------------------------------------------------------------------

OB_DIR=$(prefix)

# ----------------------------------------------------------------------
# Experts only: You can modify the lines below, for example to change
# the settings for code optimizations.
# ----------------------------------------------------------------------

CXX             = cl.exe
CXXFLAGS        = /nologo /MD /W3 /GX /Zi
CXXCPP          = cl.exe /nologo /E
CPPFLAGS        = /DWIN32 # /DOB_CLEAR_MEM
LIBS		= 
GUILIBS         = /defaultlib:user32.lib gdi32.lib winmm.lib \
		  comdlg32.lib comctl32.lib
DLLLIBS         = /defaultlib:user32.lib
LINK		= link.exe
LINKFLAGS	= /nologo /debug /subsystem:console /incremental:no
LINKGUIFLAGS	= /nologo /debug /subsystem:windows /incremental:no
LINKDLLFLAGS	= /nologo /debug /dll /incremental:no
AR		= lib.exe
ARFLAGS		= /nologo

INSTALL         = copy
INSTALL_PROGRAM = $(INSTALL)
INSTALL_DATA    = $(INSTALL)

SHELL		= bash # Only needed for "nmake /f Makefile.mak test"

# ----------------------------------------------------------------------
# Don't change anything below this line
# ----------------------------------------------------------------------

!ifndef INCLUDE
!error The INCLUDE environment variable needs to be set.
!endif
!ifndef LIB
!error The LIB environment variable needs to be set.
!endif

.SUFFIXES:
.SUFFIXES:	.cpp .obj

.cpp.obj:
	$(CXX) /c $(ALL_CPPFLAGS) $(ALL_CXXFLAGS) $<

all:: $(TARGETS)

clean::
	@del /q *.obj *.bak *.flc *.pdb *.pch

!if "$(TARGETS)" != ""
clean::
	@for %i in ( $(TARGETS) ) do \
	    @if exist %i del /q %i
!endif

install::

test::

lib:
	mkdir $@

bin:
	mkdir $@
