dnl **********************************************************************
dnl
dnl Copyright (c) 1998
dnl Object-Oriented Concepts, Inc.
dnl Billerica, MA, USA
dnl
dnl Copyright (c) 1998
dnl Object-Oriented Concepts GmbH
dnl Ettlingen, Germany
dnl
dnl All Rights Reserved
dnl
dnl **********************************************************************

dnl ----------------------------------------------------------------------
dnl ORBacus-specific configuration
dnl ----------------------------------------------------------------------

AC_SUBST(OB_CPPFLAGS)
AC_SUBST(OB_LDFLAGS)
AC_SUBST(OB_LIBS)
AC_SUBST(IDL)

OB_CPPFLAGS=
OB_LDFLAGS=
OB_LIBS=
IDL=

ob_path="../ob/"
if test -f include/OB/CORBA.h
then
    ob_path=""
fi
if test -n "$with_ob" -a "$with_ob" != "no" -a "$with_ob" != "yes"
then
    ob_path="${with_ob}/"
    if test ! -f ${ob_path}include/OB/CORBA.h
    then
	ob_path="${ob_path}ob/"
    fi	
fi
if test ! -f ${ob_path}include/OB/CORBA.h
then
    AC_MSG_ERROR(Can't find ORBacus! Use the --with-ob=path option.)
fi
if test ! \( -n "$with_ob" -a "$with_ob" != "no" -a "$with_ob" != "yes" \)
then
    ob_path="\$(top_srcdir)/$ob_path"
fi
OB_LDFLAGS="$OB_LDFLAGS -L${ob_path}lib"
OB_CPPFLAGS="$OB_CPPFLAGS -I${ob_path}include"
OB_LIBS="$OB_LIBS -lOB"
IDL="${ob_path}bin/idl"

AC_ARG_WITH(jtc,
  --with-jtc              make use of JThreads/C++,
builtin(include,../config/threads.m4)
jtc_path="../jtc/"
if test -f include/JTC/Thread.h
then
    jtc_path=""
fi
if test -n "$with_jtc" -a "$with_jtc" != "no" -a "$with_jtc" != "yes"
then
    jtc_path="${with_jtc}/"
    if test ! -f ${jtc_path}include/JTC/Thread.h
    then
	jtc_path="${jtc_path}jtc/"
    fi	
fi
if test ! -f ${jtc_path}include/JTC/Thread.h
then
    AC_MSG_ERROR(Can't find JThreads/C++! Use the --with-jtc=path option.)
fi
if test ! \( -n "$with_jtc" -a "$with_jtc" != "no" -a "$with_jtc" != "yes" \)
then
    jtc_path="\$(top_srcdir)/$jtc_path"
fi
OB_LDFLAGS="$OB_LDFLAGS -L${jtc_path}lib"
OB_CPPFLAGS="$OB_CPPFLAGS -I${jtc_path}include"
OB_LIBS="$OB_LIBS -lJTC"
AC_DEFINE(HAVE_JTC))
