// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <OB/EventServerAdmin_skel.h>
#include <OB/CosTypedEventChannelAdmin.h>

#include <EventServerAdmin_impl.h>

EventServerAdmin_impl::EventServerAdmin_impl(
    CORBA_BOA_ptr boa,
    CosEventChannelAdmin_EventChannel_ptr c)

    : boa_(CORBA_BOA::_duplicate(boa)),
      ec_(CosEventChannelAdmin_EventChannel::_duplicate(c))
{
}
    
EventServerAdmin_impl::EventServerAdmin_impl(
    CORBA_BOA_ptr boa,
    CosTypedEventChannelAdmin_TypedEventChannel_ptr c)

    : boa_(CORBA_BOA::_duplicate(boa)),
      tec_(CosTypedEventChannelAdmin_TypedEventChannel::_duplicate(c))
{
}
    
void
EventServerAdmin_impl::shutdown()
{
    JTCSynchronized sync(*this);

    if(CORBA_is_nil(boa_))
	return;

    if(!CORBA_is_nil(ec_))
    {
	ec_ -> destroy();
	ec_ = CosEventChannelAdmin_EventChannel::_nil();
    }
    if(!CORBA_is_nil(tec_))
    {
	tec_ -> destroy();
	tec_ = CosTypedEventChannelAdmin_TypedEventChannel::_nil();
    }

    boa_ -> deactivate_impl(CORBA_ImplementationDef::_nil());
    boa_ = CORBA_BOA::_nil();
}
