# **********************************************************************
#
# Copyright (c) 1998
# Object-Oriented Concepts, Inc.
# Billerica, MA, USA
#
# Copyright (c) 1998
# Object-Oriented Concepts GmbH
# Ettlingen, Germany
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..

LIB_NAME	= $(top_srcdir)\lib\CosEvent.lib
ADMIN_NAME	= $(top_srcdir)\bin\eventadmin.exe
SERVER_NAME	= $(top_srcdir)\bin\eventserv.exe
SERVICE_NAME    = $(top_srcdir)\bin\nteventservice.exe

TARGETS		= $(LIB_NAME) \
		  $(ADMIN_NAME) \
		  $(SERVER_NAME) \
		  $(SERVICE_NAME)

!include $(top_srcdir)\config\Make.rules.mak

IDLDIR		= $(top_srcdir)\idl
HDIR		= $(top_srcdir)\include\OB

LIB_OBJS	= CosEventComm.obj \
		  CosEventChannelAdmin.obj \
		  CosEventComm_skel.obj \
		  CosTypedEventComm.obj \
		  CosTypedEventChannelAdmin.obj \
		  CosTypedEventComm_skel.obj \
		  EventServerAdmin.obj

COMMON_OBJS	=

ADMIN_OBJS	= EventAdmin.obj

COMMON_SERVICE_OBJS	= \
		  EC_EventChannel_impl.obj \
		  EC_ConsumerAdmin_impl.obj \
		  EC_SupplierAdmin_impl.obj \
		  EC_ProxyPushConsumer_impl.obj \
		  EC_ProxyPushSupplier_impl.obj \
		  EC_ProxyPullSupplier_impl.obj \
		  EC_ProxyPullConsumer_impl.obj \
		  TEC_TypedEventChannel_impl.obj \
		  TEC_TypedConsumerAdmin_impl.obj \
		  TEC_TypedSupplierAdmin_impl.obj \
		  TEC_TypedProxyPushConsumer_impl.obj \
		  TEC_ProxyPushSupplier_impl.obj \
		  Event_impl.obj \
		  PropagatorBaseThread.obj \
		  PusherBaseThread.obj \
		  ProxyConsumer_impl.obj \
		  ProxySupplier_impl.obj \
		  EventUtil.obj \
		  CosEventChannelAdmin_skel.obj \
		  CosTypedEventChannelAdmin_skel.obj \
		  EventServerAdmin_skel.obj \
		  SetDefaultProperties.obj \
		  EventServerAdmin_impl.obj \
		  QoS.obj

SERVICE_OBJS	= NTEventService.obj \
		  NTServiceMain.obj \
		  EventMsg.res

SERVER_OBJS	= Server.obj

ALL_CXXFLAGS	= $(CXXFLAGS)
ALL_CPPFLAGS	= /I. /I$(top_srcdir)\include $(OB_CPPFLAGS) $(CPPFLAGS)
ALL_LIBS	= $(LIB_NAME) $(OB_LIBS) $(LIBS)
 
$(LIB_NAME): $(LIB_OBJS)
	$(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

$(SERVER_NAME): $(COMMON_OBJS) $(COMMON_SERVICE_OBJS) $(SERVER_OBJS) $(LIB_NAME)
	$(LINK) /fixed:no $(LINKFLAGS) /out:$@ \
	$(COMMON_OBJS) $(COMMON_SERVICE_OBJS) $(SERVER_OBJS) $(ALL_LIBS)

$(SERVICE_NAME): $(COMMON_OBJS) $(COMMON_SERVICE_OBJS) $(SERVICE_OBJS) \
			$(LIB_NAME)
	$(LINK) /fixed:no $(LINKFLAGS) /out:$@ \
	$(COMMON_OBJS) $(COMMON_SERVICE_OBJS) $(SERVICE_OBJS) \
	$(ALL_LIBS)

$(ADMIN_NAME): $(COMMON_OBJS) $(ADMIN_OBJS) $(LIB_NAME)
	$(LINK) /fixed:no $(LINKFLAGS) /out:$@ \
	$(COMMON_OBJS) $(ADMIN_OBJS) $(ALL_LIBS)

CosEventChannelAdmin.cpp $(HDIR)\CosEventChannelAdmin.h: \
					$(IDLDIR)\CosEventChannelAdmin.idl
	del /q CosEventChannelAdmin.cpp
	del /q $(HDIR)\CosEventChannelAdmin.h
	del /q CosEventChannelAdmin_skel.cpp
	del /q $(HDIR)\CosEventChannelAdmin_skel.h
	$(IDL) -I$(IDLDIR) --header-dir OB \
	$(IDLDIR)\CosEventChannelAdmin.idl
	move CosEventChannelAdmin.h $(HDIR)
	move CosEventChannelAdmin_skel.h $(HDIR)

CosEventChannelAdmin_skel.cpp $(HDIR)\CosEventChannelAdmin_skel.h: \
						CosEventChannelAdmin.cpp

CosEventComm.cpp $(HDIR)\CosEventComm.h: $(IDLDIR)\CosEventComm.idl
	del /q CosEventComm.cpp $(HDIR)\CosEventComm.h
	del /q CosEventComm_skel.cpp $(HDIR)\CosEventComm_skel.h
	$(IDL) -I$(IDLDIR) --header-dir OB \
	$(IDLDIR)\CosEventComm.idl
	move CosEventComm.h $(HDIR)
	move CosEventComm_skel.h $(HDIR)

CosEventComm_skel.cpp $(HDIR)\CosEventComm_skel.h: CosEventComm.cpp

CosTypedEventChannelAdmin.cpp $(HDIR)\CosTypedEventChannelAdmin.h: \
					$(IDLDIR)\CosTypedEventChannelAdmin.idl
	del /q CosTypedEventChannelAdmin.cpp
	del /q $(HDIR)\CosTypedEventChannelAdmin.h
	del /q CosTypedEventChannelAdmin_skel.cpp
	del /q $(HDIR)\CosTypedEventChannelAdmin_skel.h
	$(IDL) -I$(IDLDIR) --header-dir OB \
	$(IDLDIR)\CosTypedEventChannelAdmin.idl
	move CosTypedEventChannelAdmin.h $(HDIR)
	move CosTypedEventChannelAdmin_skel.h $(HDIR)

CosTypedEventChannelAdmin_skel.cpp $(HDIR)\CosTypedEventChannelAdmin_skel.h: \
						  CosTypedEventChannelAdmin.cpp

CosTypedEventComm.cpp $(HDIR)\CosTypedEventComm.h: \
						$(IDLDIR)\CosTypedEventComm.idl
	del /q CosTypedEventComm.cpp $(HDIR)\CosTypedEventComm.h
	del /q CosTypedEventComm_skel.cpp $(HDIR)\CosTypedEventComm_skel.h
	$(IDL) -I$(IDLDIR) --header-dir OB \
        $(IDLDIR)\CosTypedEventComm.idl
	move CosTypedEventComm.h $(HDIR)
	move CosTypedEventComm_skel.h $(HDIR)

CosTypedEventComm_skel.cpp $(HDIR)\CosTypedEventComm_skel.h: \
						          CosTypedEventComm.cpp

EventServerAdmin.cpp $(HDIR)\EventServerAdmin.h: \
						$(IDLDIR)\EventServerAdmin.idl
	del /q EventServerAdmin.cpp $(HDIR)\EventServerAdmin.h
	del /q EventServerAdmin_skel.cpp $(HDIR)\EventServerAdmin_skel.h
	$(IDL) -I$(IDLDIR) --header-dir OB \
        $(IDLDIR)\EventServerAdmin.idl
	move EventServerAdmin.h $(HDIR)
	move EventServerAdmin_skel.h $(HDIR)

EventServerAdmin_skel.cpp $(HDIR)\EventServerAdmin_skel.h: \
						          EventServerAdmin.cpp

EventMsg.rc : EventMsg.mc
	mc EventMsg.mc

EventMsg.res: EventMsg.rc
	rc -r -fo EventMsg.res EventMsg.rc

EventMsg.h : EventMsg.rc

NTServiceMain : NTEventService.h

NTEventService.cpp : EventMsg.h NTEventService.h EventServerAdmin_impl.h \
			EC_EventChannel_impl.h TEC_TypedEventChannel_impl.h

Config.h:
	echo /* dummy file */ > $@

install:: all
	$(INSTALL_DATA) $(LIB_NAME) $(libdir)
	$(INSTALL_PROGRAM) $(SERVER_NAME) $(bindir)

!include .windep
