// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef NAMING_LOGGER_H
#define NAMING_LOGGER_H

//
// Forward declarations
//
class NamingDatabase;

#ifdef HAVE_JTC
//
// This class is used to update the database journal on a regular
// basis.
//
class Logger : public JTCThread, public JTCMonitor
{
    NamingDatabase* store_;

    long interval_; // timeout interval
    bool stop_;

public:

    Logger(NamingDatabase*, long);

    void halt();

    virtual void run();
};

#else

//
// This class is used to update the database journal on a regular
// basis.
//
class Logger : public OBTimer
{
    NamingDatabase* store_;

    struct timeval interval_; // timeout interval

public:

    Logger(NamingDatabase*, long);

    virtual void notify();
};

#endif

#endif
