# **********************************************************************
#
# Copyright (c) 1998
# Object-Oriented Concepts, Inc.
# Billerica, MA, USA
#
# Copyright (c) 1998
# Object-Oriented Concepts GmbH
# Ettlingen, Germany
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..

LIB_NAME	= $(top_srcdir)\lib\CosNaming.lib
DUMP_NAME	= $(top_srcdir)\bin\dump.exe
SERVER_NAME	= $(top_srcdir)\bin\nameserv.exe

TARGETS		= $(LIB_NAME) \
		  $(SERVER_NAME) \
		  $(SERVICE_NAME) \
		  $(DUMP_NAME)

!include $(top_srcdir)\config\Make.rules.mak

IDLDIR		= $(top_srcdir)\idl
HDIR		= $(top_srcdir)\include\OB

LIB_OBJS	= CosNaming.obj \
		  CosNaming_skel.obj \
		  ExtNaming.obj \
		  ExtNaming_skel.obj

COMMON_OBJS	=

CLIENT_OBJS	=

COMMON_SERVER_OBJS = \
		  Types.obj \
		  ExtNaming_impl.obj \
		  NamingDatabase.obj \
		  NamingContextSet.obj \
		  Logger.obj

SERVER_OBJS =	  Server.obj

!if "$(WITH_JTC)" == "yes" # The NT service requires JThreads/C++

SERVICE_NAME	= $(top_srcdir)\bin\ntnameservice.exe

SERVICE_OBJS =	  NTServiceMain.obj \
		  NTNamingService.obj \
		  NamingMsg.res

!endif
		
DUMP_OBJS	= DumpAny.obj

ALL_CXXFLAGS	= $(CXXFLAGS)
ALL_CPPFLAGS	= /I. /I$(top_srcdir)\include $(OB_CPPFLAGS) $(CPPFLAGS)
ALL_LIBS	= $(LIB_NAME) $(OB_LIBS) $(LIBS)
 
$(LIB_NAME): $(LIB_OBJS)
	$(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

$(SERVER_NAME): $(COMMON_OBJS) $(COMMON_SERVER_OBJS) $(SERVER_OBJS)
	$(LINK) $(LINKFLAGS) /out:$@ \
	$(COMMON_OBJS) $(COMMON_SERVER_OBJS) $(SERVER_OBJS) $(ALL_LIBS)

!if "$(WITH_JTC)" == "yes" # The NT service requires JThreads/C++
$(SERVICE_NAME): $(COMMON_OBJS) $(COMMON_SERVER_OBJS) $(SERVICE_OBJS)
	$(LINK) $(LINKFLAGS) /out:$@ \
	$(COMMON_OBJS) $(COMMON_SERVER_OBJS) $(SERVICE_OBJS) $(ALL_LIBS)

all:: $(SERVICE_NAME)
!endif

$(DUMP_NAME): $(COMMON_OBJS) $(DUMP_OBJS)
	$(LINK) $(LINKFLAGS) /out:$@ \
	$(COMMON_OBJS) $(DUMP_OBJS) $(ALL_LIBS)

CosNaming.cpp $(HDIR)\CosNaming.h: $(IDLDIR)\CosNaming.idl
	del /q CosNaming.cpp $(HDIR)\CosNaming.h
	del /q CosNaming_skel.cpp $(HDIR)\CosNaming_skel.h
	$(IDL) -I$(IDLDIR) --header-dir OB $(IDLDIR)\CosNaming.idl
	move CosNaming.h $(HDIR)
	move CosNaming_skel.h $(HDIR)

CosNaming_skel.cpp $(HDIR)\CosNaming_skel.h: CosNaming.cpp

Types.cpp Types.h: Types.idl
	del /q Types.cpp Types.h
	$(IDL) -I$(IDLDIR) --other-header-dir OB \
	--no-skeletons Types.idl

ExtNaming.cpp (HDIR)/ExtNaming.h: $(IDLDIR)/ExtNaming.idl
	del /q ExtNaming.cpp $(HDIR)\ExtNaming.h
	del /q ExtNaming_skel.cpp $(HDIR)\ExtNaming_skel.h
	$(IDL) -I$(IDLDIR) --header-dir OB $(IDLDIR)\ExtNaming.idl
	move ExtNaming.h $(HDIR)
	move ExtNaming_skel.h $(HDIR)

NamingMsg.rc : NamingMsg.mc
	mc NamingMsg.mc

NamingMsg.res: NamingMsg.rc
	rc -r -fo NamingMsg.res NamingMsg.rc

NamingMsg.h : NamingMsg.rc

NTServiceMain.cpp : NTNamingService.h

NTNamingService.cpp : NamingMsg.h NTNamingService.h ExtNaming_impl.h \
                      NamingContextSet.h NamingDatabase.h Logger.h Types.h

Config.h:
	echo /* dummy file */ > $@

install:: all
	$(INSTALL_DATA) $(LIB_NAME) $(libdir)
	$(INSTALL_PROGRAM) $(SERVER_NAME) $(bindir)

!include .windep
