// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <OB/TemplateI.h>
#include <OB/Util.h>

#include <OB/CosNaming.h>

#include <NamingContextSet.h>

#ifndef HAVE_NO_EXPLICIT_TEMPLATES
template class OBFixSeq<CosNaming_NamingContext_ptr>;
#else
#ifdef HAVE_PRAGMA_DEFINE
#endif
#endif

// ----------------------------------------------------------------------
// NamingContextSet constructor and destructor
// ----------------------------------------------------------------------

NamingContextSet::NamingContextSet()
    : curr_(0)
{
}

NamingContextSet::~NamingContextSet()
{
}

// ----------------------------------------------------------------------
// NamingContextSet public member implementation
// ----------------------------------------------------------------------

void
NamingContextSet::add(CosNaming_NamingContext_ptr nc)
{
    contexts_.append(nc);
}

void
NamingContextSet::remove(CosNaming_NamingContext_ptr nc)
{
    for(CORBA_ULong i = 0; i < contexts_.length(); ++i)
        if(contexts_[i] == nc)
        {
            contexts_.remove(i);
            return;
        }

    assert(false);
}

CosNaming_NamingContext_ptr
NamingContextSet::first()
{
    curr_ = 0;
    return next();
}

CosNaming_NamingContext_ptr
NamingContextSet::next()
{
    if(curr_ >= contexts_.length())
        return CosNaming_NamingContext::_nil();

    return contexts_[curr_++];
}
