// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef NAMING_CONTEXT_SET_H
#define NAMING_CONTEXT_SET_H

typedef OBFixSeq<CosNaming_NamingContext_ptr> NamingContextPtrSeq;

class NamingContextSet
{
    NamingContextPtrSeq contexts_;
    CORBA_ULong curr_;

    //
    // Hide assignment and copy constructor
    //
    NamingContextSet(const NamingContextSet&);
    void operator=(const NamingContextSet&);

public:

    NamingContextSet();
    ~NamingContextSet();

    //
    // Add and remove contexts.
    //
    void add(CosNaming_NamingContext_ptr);
    void remove(CosNaming_NamingContext_ptr);

    //
    // Iterate.
    //
    CosNaming_NamingContext_ptr first();
    CosNaming_NamingContext_ptr next();
};

#endif
