// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef __TestListener_impl_h__
#define __TestListener_impl_h__

#include <OB/CORBA.h>
#include <OB/ExtNaming_skel.h>

class TestListener_impl : virtual public CosNaming_BindingListener_skel
{
public:
    enum Operation
    {
	OP_NONE,
        CONTEXT_ADDED,
        CONTEXT_REMOVED,
        CONTEXT_CHANGED,
        OBJECT_ADDED,
        OBJECT_REMOVED,
        OBJECT_CHANGED
    };

    TestListener_impl();

    void expect(Operation op, CosNaming_NamingContext_ptr ctx,
                const CosNaming_NameComponent& name);

    bool isValid();

    //
    // CosNaming::BindingListener operations
    //

    virtual void context_added(CosNaming_NamingContext_ptr ctx,
                               const CosNaming_NameComponent& name);

    virtual void context_removed(CosNaming_NamingContext_ptr ctx,
                                 const CosNaming_NameComponent& name);

    virtual void context_changed(CosNaming_NamingContext_ptr ctx,
                                 const CosNaming_NameComponent& name);

    virtual void object_added(CosNaming_NamingContext_ptr ctx,
                              const CosNaming_NameComponent& name);

    virtual void object_removed(CosNaming_NamingContext_ptr ctx,
                                const CosNaming_NameComponent& name);

    virtual void object_changed(CosNaming_NamingContext_ptr ctx,
                                const CosNaming_NameComponent& name);

private:
    void validate(Operation op,
                  CosNaming_NamingContext_ptr ctx,
                  const CosNaming_NameComponent& name);

    bool equal(const CosNaming_NameComponent& n1,
               const CosNaming_NameComponent& n2);

    void reset();

    Operation op_;
    CosNaming_NamingContext_var ctx_;
    CosNaming_NameComponent name_;
    bool valid_;
};

#endif
