# **********************************************************************
#
# Copyright (c) 1998
# Object-Oriented Concepts, Inc.
# Billerica, MA, USA
#
# Copyright (c) 1998
# Object-Oriented Concepts GmbH
# Ettlingen, Germany
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..\..

LIB_NAME	= $(top_srcdir)\lib\idl.lib
IDL_NAME	= $(top_srcdir)\bin\idl.exe
SERV_NAME	= $(top_srcdir)\bin\irserv.exe
FEED_NAME	= $(top_srcdir)\bin\irfeed.exe
DEL_NAME	= $(top_srcdir)\bin\irdel.exe
GEN_NAME	= $(top_srcdir)\bin\irgen.exe
JIDL_NAME	= $(top_srcdir)\bin\jidl.exe
HIDL_NAME	= $(top_srcdir)\bin\hidl.exe
RIDL_NAME	= $(top_srcdir)\bin\ridl.exe

TARGETS		= $(LIB_NAME) \
		  $(IDL_NAME) \
		  $(SERV_NAME) \
		  $(FEED_NAME) \
		  $(DEL_NAME) \
		  $(GEN_NAME) \
		  $(JIDL_NAME) \
		  $(HIDL_NAME) \
		  $(RIDL_NAME)

!include $(top_srcdir)\config\Make.rules.mak

IDLDIR		= $(top_srcdir)\idl

SUBDIRS		= cpp

LIB_OBJS	= Util.obj \
		  Types.obj \
		  Gram.obj \
		  GramUtil.obj \
		  Scan.obj \
		  IntRepMember_skel.obj \
		  IntRep_skel.obj \
		  IntRepMember_impl.obj \
		  IntRep_impl.obj \
		  GenCPP.obj \
		  GenCPPH.obj \
		  GenCPPC.obj \
		  GenCPPSkelH.obj \
		  GenCPPSkelC.obj \
		  GenCPPTieH.obj \
		  GenCPPUtil.obj \
		  GenUtil.obj \
		  GenJava.obj \
		  GenJavaUtil.obj \
		  GenHTML.obj \
		  GenHTMLUtil.obj \
		  GenRTF.obj \
		  GenRTFUtil.obj

IDL_OBJS	= IDL.obj
SERV_OBJS	= Server.obj
FEED_OBJS	= Feed.obj
DEL_OBJS	= Del.obj
GEN_OBJS	= Gen.obj
JIDL_OBJS	= JIDL.obj
HIDL_OBJS	= HIDL.obj
RIDL_OBJS	= RIDL.obj

ALL_CXXFLAGS	= $(CXXFLAGS)
ALL_CPPFLAGS	= /I. /Iwininclude $(OB_CPPFLAGS) $(CPPFLAGS)
ALL_LIBS	= $(LIB_NAME) $(OB_LIBS) $(LIBS)

$(LIB_NAME): $(LIB_OBJS)
	$(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

$(SERV_NAME): $(SERV_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(SERV_OBJS) $(ALL_LIBS)

$(FEED_NAME): $(FEED_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(FEED_OBJS) $(ALL_LIBS)

$(DEL_NAME): $(DEL_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(DEL_OBJS) $(ALL_LIBS)

$(GEN_NAME): $(GEN_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(GEN_OBJS) $(ALL_LIBS)

$(IDL_NAME): $(IDL_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(IDL_OBJS) $(ALL_LIBS)

$(JIDL_NAME): $(JIDL_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(JIDL_OBJS) $(ALL_LIBS)

$(HIDL_NAME): $(HIDL_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(HIDL_OBJS) $(ALL_LIBS)

$(RIDL_NAME): $(RIDL_OBJS)  $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(RIDL_OBJS) $(ALL_LIBS)

Types.cpp Types.h: Types.idl
	if exist $(IDL) \
	    del /q Types.cpp Types.h & \
	    $(IDL) -I$(IDLDIR) --other-header-dir OB \
	    --no-skeletons --no-type-codes Types.idl

install:: all
	$(INSTALL_DATA) $(LIB_NAME) $(libdir)
	$(INSTALL_PROGRAM) $(IDL_NAME) $(bindir)
	$(INSTALL_PROGRAM) $(JIDL_NAME) $(bindir)
	$(INSTALL_PROGRAM) $(HIDL_NAME) $(bindir)
	$(INSTALL_PROGRAM) $(RIDL_NAME) $(bindir)
	$(INSTALL_PROGRAM) $(SERV_NAME) $(bindir)
	$(INSTALL_PROGRAM) $(FEED_NAME) $(bindir)
	$(INSTALL_PROGRAM) $(DEL_NAME) $(bindir)
	$(INSTALL_PROGRAM) $(GEN_NAME) $(bindir)

all depend install clean test::
	@for %i in ( $(SUBDIRS) ) do \
	    @cmd /c "cd %i & $(MAKE) /f Makefile.mak $@"

!include .windep
